import numpy as np

# From: http://stackoverflow.com/a/35178910
def angle(x, y):
    a = np.array([50, 100, 0])
    b = np.array([50, 50, 0])
    c = np.array([x, y, 0])

    ba = a - b
    bc = c - b

    cosine_angle = np.dot(ba, bc) / (np.linalg.norm(ba) * np.linalg.norm(bc))
    angle = np.arccos(cosine_angle)

    return np.degrees(angle)

def solve(S):
    p, x, y = S
    #print("p={0}, x={1}, y={2}".format(p, x, y))
    dist=np.sqrt((x-50)*(x-50)+(y-50)*(y-50))
    if dist > 50:
        return 'white'
    a=angle(x,y)
    if x < 50:
        a=360-a
    #print('Angle={0}'.format(a))
    if p >= 100*a/360:
        return 'black'
    return 'white'

if __name__ == "__main__":
    import fileinput
    f = fileinput.input()

    T = int(f.readline())
    for case in range(1, T+1):
        S = [int(i) for i in f.readline().split()]
        solution = solve(S)
        print("Case #{0}: {1}".format(case, solution))
